package com.cm6123.monopoly;

import com.cm6123.monopoly.game.Player;
import com.cm6123.monopoly.game.GameAction;
import com.cm6123.monopoly.game.Board;

import org.junit.jupiter.api.Test;

import java.io.ByteArrayInputStream;

import static org.junit.jupiter.api.Assertions.*;

public class PropertyPurchaseTest {

    @Test
    public void testPlayerLandsOnUnownedProperty() {

        Board board = new Board();

        Player player = new Player("TestPlayer", 1000, 0); // Example player with £1000 starting money and at position 0
        player.setPosition(4);

        ByteArrayInputStream in = new ByteArrayInputStream("Y".getBytes());
        System.setIn(in);


        GameAction gameAction = new GameAction(board);
        gameAction.landedOnProperty(player);

        assertEquals(4, player.getPosition(), "Player should land on tile 4 (Old Kent Road)");

        System.setIn(System.in);
    }

    @Test
    public void testIfPlayerCanRePurchaseProperty() {

        Board board = new Board();

        Player owner = new Player("TestPlayer1", 1200, 0);
        board.buyProperty(4, owner);

        Player testPlayer2 = new Player("TestPlayer2", 1000, 0); // Example player with £1000 starting money and at position 0
        testPlayer2.setPosition(4);

        GameAction gameAction = new GameAction(board);
        gameAction.landedOnProperty(testPlayer2);

        assertEquals(4, testPlayer2.getPosition());

    }
}
